from app import db


class Forum(db.Model):
    __tablename__ = 'forum'
    id = db.Column(db.Integer, primary_key=True)

    # Standalone properties
    name = db.Column(db.Unicode(64))
    slug = db.Column(db.Unicode(64))
    description = db.Column(db.UnicodeText)

    # Relationships
    parent_id = db.Column(db.Integer, db.ForeignKey('forum.id'), nullable=True)
    sub_forums = db.relationship('Forum', backref='parent', lazy=True)
    topics = db.relationship('Topic', backref='forum')

    def __init__(self, name, description, priv_prefix):
        self.name = name
        self.description = description
        self.priv_prefix = priv_prefix

    def __repr__(self):
        return f'<Forum #{self.id}>'
