from app import db
from app.models.thread import Thread


class Topic(Thread):
    __tablename__ = 'topic'
    id = db.Column(db.Integer, db.ForeignKey('thread.id'), primary_key=True)
    __mapper_args__ = {'polymorphic_identity': __tablename__}

    # Relationships
    forum_id = db.Column(db.Integer, db.ForeignKey('forum.id'), nullable=False)

    def __init__(self, author, text, title, forum):
        """ Create a Topic """
        super.__init__(author, text, title)
        if isinstance(forum, Forum):
            forum = forum.id
            self.forum_id = forum

    def __repr__(self):
        return f'<Topic #{self.id}'
